# EC Client Angular

Edge central client library designed for Angular framework

## Getting Started

To use this library simply add to your package dep. and register on your root modules with desired configurations.

1. install using npm

    ```bash
    npm i @sirusdev/ec-client-angular
    ```

2. register this client on root modules

    ```typescript
    @NgModule({
      declarations: [AppComponent],
      entryComponents: [],
      imports: [
        ...
        EdgeCentralModule.forRoot({
          edgeCN: 'ec.qh.sirus.dev',
          ecvcHost: 'ecvc.qh.sirus.dev',
          cloudCentralHost: 'api-cc.qh.sirus.dev',
          // set insecure to true when you are using insecure endpoint like localahost
          inSecure: true // optional
        }),
      ],
      ...
      bootstrap: [AppComponent]
    })
    ```
