(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ionic/angular'), require('@angular/forms'), require('@angular/common'), require('@angular/router'), require('bluebird'), require('@sirusdev/ec-client-angular')) :
    typeof define === 'function' && define.amd ? define('@sirusdev/ec-client-angular/login', ['exports', '@angular/core', '@ionic/angular', '@angular/forms', '@angular/common', '@angular/router', 'bluebird', '@sirusdev/ec-client-angular'], factory) :
    (global = global || self, factory((global.sirusdev = global.sirusdev || {}, global.sirusdev['ec-client-angular'] = global.sirusdev['ec-client-angular'] || {}, global.sirusdev['ec-client-angular'].login = {}), global.ng.core, global.angular, global.ng.forms, global.ng.common, global.ng.router, global.bluebird, global.sirusdev['ec-client-angular']));
}(this, (function (exports, core, angular, forms, common, router, bluebird, ecClientAngular) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/components/login.page.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoginPage = /** @class */ (function () {
        function LoginPage(toast, loading, router, ec) {
            this.toast = toast;
            this.loading = loading;
            this.router = router;
            this.ec = ec;
            this.tab = 'device';
        }
        /**
         * @param {?} event
         * @return {?}
         */
        LoginPage.prototype.tabChanged = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.tab = event.detail.value;
        };
        /**
         * @return {?}
         */
        LoginPage.prototype.loginDevice = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var loading, err_1, toast;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.loading.create({
                                message: 'Menghubungkan...'
                            })];
                        case 1:
                            loading = _a.sent();
                            return [4 /*yield*/, loading.present()];
                        case 2:
                            _a.sent();
                            _a.label = 3;
                        case 3:
                            _a.trys.push([3, 6, , 9]);
                            return [4 /*yield*/, this.ec.loginByDevice(this.deviceID)];
                        case 4:
                            _a.sent();
                            // wait local storage to persist
                            return [4 /*yield*/, bluebird.delay(500)];
                        case 5:
                            // wait local storage to persist
                            _a.sent();
                            window.location.replace('/');
                            return [3 /*break*/, 9];
                        case 6:
                            err_1 = _a.sent();
                            return [4 /*yield*/, this.toast.create({
                                    message: err_1.message || err_1.toString(),
                                    color: 'danger',
                                    duration: 5000
                                })];
                        case 7:
                            toast = _a.sent();
                            return [4 /*yield*/, toast.present()];
                        case 8:
                            _a.sent();
                            return [3 /*break*/, 9];
                        case 9: return [4 /*yield*/, loading.dismiss()];
                        case 10:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @return {?}
         */
        LoginPage.prototype.loginProvider = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var loading, err_2, toast;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.loading.create({
                                message: 'Menghubungkan...'
                            })];
                        case 1:
                            loading = _a.sent();
                            return [4 /*yield*/, loading.present()];
                        case 2:
                            _a.sent();
                            _a.label = 3;
                        case 3:
                            _a.trys.push([3, 6, , 9]);
                            return [4 /*yield*/, this.ec.loginByProvider(this.providerID, this.password)];
                        case 4:
                            _a.sent();
                            // wait local storage to persist
                            return [4 /*yield*/, bluebird.delay(500)];
                        case 5:
                            // wait local storage to persist
                            _a.sent();
                            window.location.replace('/');
                            return [3 /*break*/, 9];
                        case 6:
                            err_2 = _a.sent();
                            return [4 /*yield*/, this.toast.create({
                                    message: err_2.message || err_2.toString(),
                                    color: 'danger',
                                    duration: 5000
                                })];
                        case 7:
                            toast = _a.sent();
                            return [4 /*yield*/, toast.present()];
                        case 8:
                            _a.sent();
                            return [3 /*break*/, 9];
                        case 9: return [4 /*yield*/, loading.dismiss()];
                        case 10:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        LoginPage.decorators = [
            { type: core.Component, args: [{
                        selector: 'qh-login-page',
                        template: "<ion-header translucent>\r\n  <ion-toolbar>\r\n    <ion-title>Login</ion-title>\r\n  </ion-toolbar>\r\n</ion-header>\r\n\r\n<ion-content>\r\n  <ion-grid>\r\n    <ion-row class=\"ion-align-items-center ion-justify-content-center\">\r\n      <ion-col size-md=\"8\" size-sm>\r\n        <ion-card>\r\n          <ion-card-header>\r\n            <ion-segment (ionChange)=\"tabChanged($event)\" [value]=\"tab\">\r\n              <ion-segment-button value=\"device\" id=\"login-device\">\r\n                <ion-label>Login dengan kode perangkat</ion-label>\r\n              </ion-segment-button>\r\n              <ion-segment-button value=\"provider\" id=\"login-provider\">\r\n                <ion-label>Login dengan kode faskes</ion-label>\r\n              </ion-segment-button>\r\n            </ion-segment>\r\n          </ion-card-header>\r\n\r\n          <ion-card-content>\r\n            <ng-container *ngIf=\"tab === 'device'\">\r\n              <form ngForm #loginDeviceForm=\"ngForm\">\r\n                <ion-list lines=\"full\" class=\"ion-no-margin ion-no-padding\">\r\n                  <ion-item>\r\n                    <ion-label position=\"floating\">\r\n                      kode perangkat\r\n                      <ion-text\r\n                        color=\"danger\"\r\n                        *ngIf=\"device_id.invalid && (device_id.dirty || device_id.touched)\"\r\n                      >\r\n                        <span *ngIf=\"device_id?.errors?.required\">\r\n                          wajib diisi\r\n                        </span>\r\n                      </ion-text>\r\n                    </ion-label>\r\n                    <ion-input\r\n                      name=\"device_id\"\r\n                      [(ngModel)]=\"deviceID\"\r\n                      type=\"text\"\r\n                      placeholder=\"misal prkt123\"\r\n                      required\r\n                      #device_id=\"ngModel\"\r\n                      id=\"device-id\"\r\n                    ></ion-input>\r\n                  </ion-item>\r\n                </ion-list>\r\n                <div class=\"ion-padding\">\r\n                  <ion-button\r\n                    shape=\"round\"\r\n                    expand=\"block\"\r\n                    color=\"primary\"\r\n                    (click)=\"loginDevice()\"\r\n                    [disabled]=\"!loginDeviceForm.form.valid\"\r\n                    id=\"submit-device\"\r\n                  >\r\n                    <ion-icon slot=\"start\" name=\"unlock\"></ion-icon>\r\n                    Login\r\n                  </ion-button>\r\n                </div>\r\n              </form>\r\n            </ng-container>\r\n\r\n            <ng-container *ngIf=\"tab === 'provider'\">\r\n              <form ngForm #loginProviderForm=\"ngForm\">\r\n                <ion-list lines=\"full\" class=\"ion-no-margin ion-no-padding\">\r\n                  <ion-item>\r\n                    <ion-label position=\"floating\">\r\n                      kode faskes\r\n                      <ion-text\r\n                        color=\"danger\"\r\n                        *ngIf=\"provider_id.invalid && (provider_id.dirty || provider_id.touched)\"\r\n                      >\r\n                        <span *ngIf=\"provider_id?.errors?.required\">\r\n                          wajib diisi\r\n                        </span>\r\n                      </ion-text>\r\n                    </ion-label>\r\n                    <ion-input\r\n                      name=\"provider_id\"\r\n                      [(ngModel)]=\"providerID\"\r\n                      type=\"text\"\r\n                      placeholder=\"misal klinik_sehat\"\r\n                      required\r\n                      #provider_id=\"ngModel\"\r\n                      id=\"provider-code\"\r\n                    ></ion-input>\r\n                  </ion-item>\r\n\r\n                  <ion-item>\r\n                    <ion-label position=\"floating\">\r\n                      password\r\n                      <ion-text\r\n                        color=\"danger\"\r\n                        *ngIf=\"passwords.invalid && (passwords.dirty || passwords.touched)\"\r\n                      >\r\n                        <span *ngIf=\"passwords?.errors?.required\">\r\n                          wajib diisi\r\n                        </span>\r\n                      </ion-text>\r\n                    </ion-label>\r\n                    <ion-input\r\n                      name=\"password\"\r\n                      [(ngModel)]=\"password\"\r\n                      type=\"password\"\r\n                      required\r\n                      #passwords=\"ngModel\"\r\n                      id=\"provider-password\"\r\n                    ></ion-input>\r\n                  </ion-item>\r\n                </ion-list>\r\n\r\n                <div class=\"ion-padding\">\r\n                  <ion-button\r\n                    shape=\"round\"\r\n                    expand=\"block\"\r\n                    color=\"primary\"\r\n                    (click)=\"loginProvider()\"\r\n                    [disabled]=\"!loginProviderForm.form.valid\"\r\n                    id=\"submit-provider\"\r\n                  >\r\n                    <ion-icon slot=\"start\" name=\"unlock\"></ion-icon>\r\n                    Login\r\n                  </ion-button>\r\n                </div>\r\n              </form>\r\n            </ng-container>\r\n          </ion-card-content>\r\n        </ion-card>\r\n      </ion-col>\r\n    </ion-row>\r\n  </ion-grid>\r\n</ion-content>\r\n"
                    }] }
        ];
        /** @nocollapse */
        LoginPage.ctorParameters = function () { return [
            { type: angular.ToastController },
            { type: angular.LoadingController },
            { type: router.Router },
            { type: ecClientAngular.EdgeCentralClient }
        ]; };
        return LoginPage;
    }());
    if (false) {
        /** @type {?} */
        LoginPage.prototype.tab;
        /** @type {?} */
        LoginPage.prototype.deviceID;
        /** @type {?} */
        LoginPage.prototype.providerID;
        /** @type {?} */
        LoginPage.prototype.password;
        /**
         * @type {?}
         * @private
         */
        LoginPage.prototype.toast;
        /**
         * @type {?}
         * @private
         */
        LoginPage.prototype.loading;
        /**
         * @type {?}
         * @private
         */
        LoginPage.prototype.router;
        /**
         * @type {?}
         * @private
         */
        LoginPage.prototype.ec;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ec-login.router.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var routes = [{ path: '', component: LoginPage }];
    /**
     * Login Router modules
     * @export
     */
    var EdgeCentralLoginRoutingModule = /** @class */ (function () {
        function EdgeCentralLoginRoutingModule() {
        }
        EdgeCentralLoginRoutingModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [router.RouterModule.forChild(routes)],
                        exports: [router.RouterModule],
                        declarations: []
                    },] }
        ];
        return EdgeCentralLoginRoutingModule;
    }());
    /** @type {?} */
    var routedComponents = [LoginPage];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ec-login.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Module to provide context user interface before accessing edge central features
     *
     * @export
     */
    var EdgeCentralLoginModule = /** @class */ (function () {
        function EdgeCentralLoginModule() {
        }
        EdgeCentralLoginModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            angular.IonicModule,
                            common.CommonModule,
                            EdgeCentralLoginRoutingModule,
                            forms.FormsModule,
                            forms.ReactiveFormsModule
                        ],
                        declarations: __spread(routedComponents)
                    },] }
        ];
        return EdgeCentralLoginModule;
    }());

    exports.EdgeCentralLoginModule = EdgeCentralLoginModule;
    exports.ɵa = EdgeCentralLoginRoutingModule;
    exports.ɵb = routedComponents;
    exports.ɵc = LoginPage;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sirusdev-ec-client-angular-login.umd.js.map
