(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('localforage'), require('subscriptions-transport-ws'), require('apollo-client'), require('apollo-link-http'), require('apollo-link-ws'), require('apollo-cache-inmemory'), require('apollo-link'), require('apollo-utilities'), require('bluebird'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('@sirusdev/ec-client-angular', ['exports', 'localforage', 'subscriptions-transport-ws', 'apollo-client', 'apollo-link-http', 'apollo-link-ws', 'apollo-cache-inmemory', 'apollo-link', 'apollo-utilities', 'bluebird', '@angular/core'], factory) :
    (global = global || self, factory((global.sirusdev = global.sirusdev || {}, global.sirusdev['ec-client-angular'] = {}), global.localforage, global.subscriptionsTransportWs, global.apolloClient, global.apolloLinkHttp, global.apolloLinkWs, global.apolloCacheInmemory, global.apolloLink, global.apolloUtilities, global.bluebird, global.ng.core));
}(this, (function (exports, localforage, subscriptionsTransportWs, apolloClient, apolloLinkHttp, apolloLinkWs, apolloCacheInmemory, apolloLink, apolloUtilities, bluebird, core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/services/ec.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function ECLite() { }
    if (false) {
        /** @type {?} */
        ECLite.prototype.fetch;
        /** @type {?} */
        ECLite.prototype.WebSocket;
    }
    var EdgeCentralConfig = /** @class */ (function () {
        function EdgeCentralConfig() {
        }
        return EdgeCentralConfig;
    }());
    if (false) {
        /** @type {?} */
        EdgeCentralConfig.prototype.cloudCentralHost;
        /** @type {?} */
        EdgeCentralConfig.prototype.edgeCN;
        /** @type {?} */
        EdgeCentralConfig.prototype.ecvcHost;
        /** @type {?} */
        EdgeCentralConfig.prototype.inSecure;
    }
    /**
     * @record
     */
    function EdgeCentralClientConfig() { }
    if (false) {
        /** @type {?} */
        EdgeCentralClientConfig.prototype.apiUrl;
        /** @type {?} */
        EdgeCentralClientConfig.prototype.subscriptionUrl;
        /** @type {?} */
        EdgeCentralClientConfig.prototype.token;
    }
    var EdgeCentralClient = /** @class */ (function () {
        /* eslint-disable no-useless-constructor */
        function EdgeCentralClient(config) {
            this.config = config;
            this.httpProtocol = 'https';
            this.wsProtocol = 'wss';
            this.store = localforage.createInstance({
                name: 'ec-client',
                driver: localforage.LOCALSTORAGE
            });
            if (config.inSecure) {
                // set protocol to insecure protocol
                this.httpProtocol = 'http';
                this.wsProtocol = 'ws';
            }
        }
        /**
         * @return {?}
         */
        EdgeCentralClient.prototype.isAuthenticated = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var config;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: 
                        // TODO: use more shopisticated detection mechanism
                        return [4 /*yield*/, bluebird.delay(500)];
                        case 1:
                            // TODO: use more shopisticated detection mechanism
                            _a.sent();
                            /* eslint-disable no-console */
                            console.log('using chrome extensions?', this.isUsingChromeExtension());
                            if (this.isUsingChromeExtension()) {
                                return [2 /*return*/, true];
                            }
                            return [4 /*yield*/, this.getClientConfig()];
                        case 2:
                            config = _a.sent();
                            if (!config.token) {
                                return [2 /*return*/, false];
                            }
                            return [2 /*return*/, true];
                    }
                });
            });
        };
        /**
         * return true when chrome inject script from ec-lite extenstion are presents
         */
        /**
         * return true when chrome inject script from ec-lite extenstion are presents
         * @return {?}
         */
        EdgeCentralClient.prototype.isUsingChromeExtension = /**
         * return true when chrome inject script from ec-lite extenstion are presents
         * @return {?}
         */
        function () {
            if (window.eclite) {
                return true;
            }
            return false;
        };
        /**
         * @return {?}
         */
        EdgeCentralClient.prototype.loadApolloClient = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = this;
                            return [4 /*yield*/, this.createApolloClient()];
                        case 1:
                            _a.client = _b.sent();
                            console.log('client loaded!', this.client);
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @return {?}
         */
        EdgeCentralClient.prototype.createApolloClient = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var config, httpLink, wsClient, wsLink, cache, link, client;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: 
                        // TODO: use more shopisticated detection mechanism
                        return [4 /*yield*/, bluebird.delay(500)];
                        case 1:
                            // TODO: use more shopisticated detection mechanism
                            _a.sent();
                            // get client configurations
                            return [4 /*yield*/, this.getClientConfig()];
                        case 2:
                            config = _a.sent();
                            // HTTP connection to the API
                            httpLink = apolloLinkHttp.createHttpLink({
                                uri: config.apiUrl,
                                fetch: (/**
                                 * @param {?} input
                                 * @param {?} init
                                 * @return {?}
                                 */
                                function (input, init) { return __awaiter(_this, void 0, void 0, function () {
                                    var conf, url;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, this.getClientConfig()];
                                            case 1:
                                                conf = _a.sent();
                                                url = conf.apiUrl || input;
                                                // set authorization header
                                                if (init.headers && init.headers.set) {
                                                    init.headers.set('Authorization', "Bearer " + conf.token);
                                                }
                                                else {
                                                    init.headers = init.headers || ((/** @type {?} */ ({})));
                                                    init.headers.Authorization = "Bearer " + conf.token;
                                                }
                                                // using eclite offline first fetch
                                                // when chrome extension are present
                                                if (this.isUsingChromeExtension()) {
                                                    return [2 /*return*/, window.eclite.fetch(url, init)];
                                                }
                                                return [2 /*return*/, fetch(url, init)];
                                        }
                                    });
                                }); })
                            });
                            // subscriptions link
                            wsClient = new subscriptionsTransportWs.SubscriptionClient(config.subscriptionUrl, {
                                reconnect: true,
                                connectionParams: {
                                    token: config.token
                                }
                            }, 
                            // using eclite offline first websocket
                            // when chrome extension are present
                            this.isUsingChromeExtension() ? window.eclite.WebSocket : WebSocket);
                            wsLink = new apolloLinkWs.WebSocketLink(wsClient);
                            // Cache implementation
                            cache = new apolloCacheInmemory.InMemoryCache();
                            // using the ability to split links, you can send data to each link
                            // depending on what kind of operation is being sent
                            link = apolloLink.split((
                            // split based on operation type
                            // split based on operation type
                            /**
                             * @param {?} __0
                             * @return {?}
                             */
                            function (_a) {
                                var query = _a.query;
                                /** @type {?} */
                                var definition = apolloUtilities.getMainDefinition(query);
                                return (definition.kind === 'OperationDefinition' &&
                                    definition.operation === 'subscription');
                            }), wsLink, httpLink);
                            // Create apollo client
                            client = new apolloClient.ApolloClient({
                                link: link,
                                cache: cache
                            });
                            return [2 /*return*/, client];
                    }
                });
            });
        };
        /**
         * @param {?} config
         * @return {?}
         */
        EdgeCentralClient.prototype.setClientConfig = /**
         * @param {?} config
         * @return {?}
         */
        function (config) {
            return this.store.setItem('config', config);
        };
        /**
         * @return {?}
         */
        EdgeCentralClient.prototype.getClientConfig = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var config;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.store.getItem('config')];
                        case 1:
                            config = _a.sent();
                            // using default config when config not present
                            if (!config) {
                                return [2 /*return*/, {
                                        apiUrl: "https://" + this.config.ecvcHost + "/graphql",
                                        subscriptionUrl: "wss://" + this.config.ecvcHost + "/subscriptions",
                                        token: null
                                    }];
                            }
                            return [2 /*return*/, config];
                    }
                });
            });
        };
        /**
         * logout and clear client contexts
         */
        /**
         * logout and clear client contexts
         * @return {?}
         */
        EdgeCentralClient.prototype.logout = /**
         * logout and clear client contexts
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.store.removeItem('config')];
                        case 1:
                            _a.sent();
                            window.location.replace('/login');
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {?} providerId
         * @param {?} password
         * @return {?}
         */
        EdgeCentralClient.prototype.loginByProvider = /**
         * @param {?} providerId
         * @param {?} password
         * @return {?}
         */
        function (providerId, password) {
            return __awaiter(this, void 0, void 0, function () {
                var res, errMessage, token;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, fetch(this.httpProtocol + "://" + this.config.cloudCentralHost + "/login-provider", {
                                method: 'POST',
                                mode: 'cors',
                                headers: {
                                    'Content-Type': 'application/json'
                                },
                                body: JSON.stringify({
                                    provider_id: providerId,
                                    password: password
                                })
                            })];
                        case 1:
                            res = _a.sent();
                            if (!res.ok) {
                                errMessage = 'Gagal melakukan login';
                                switch (res.status) {
                                    case 404:
                                    case 403:
                                    case 401:
                                        errMessage = 'Kode Faskes & Password tidak cocok';
                                        break;
                                    case 500:
                                        errMessage = 'Maaf, Server kami mengalami gangguan';
                                        break;
                                }
                                throw new Error(errMessage);
                            }
                            // get token
                            return [4 /*yield*/, res.json()];
                        case 2:
                            token = (_a.sent()).token;
                            // apply configurations
                            return [4 /*yield*/, this.setClientConfig({
                                    apiUrl: this.httpProtocol + "://" + this.config.ecvcHost + "/graphql",
                                    subscriptionUrl: this.wsProtocol + "://" + this.config.ecvcHost + "/subscriptions",
                                    token: token
                                })];
                        case 3:
                            // apply configurations
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {?} deviceId
         * @return {?}
         */
        EdgeCentralClient.prototype.loginByDevice = /**
         * @param {?} deviceId
         * @return {?}
         */
        function (deviceId) {
            return __awaiter(this, void 0, void 0, function () {
                var apiUrl, subscriptionUrl, err_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            apiUrl = this.httpProtocol + "://" + deviceId + "." + this.config.edgeCN + "/graphql";
                            subscriptionUrl = this.wsProtocol + "://" + deviceId + "." + this.config.edgeCN + "/subscriptions";
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, fetch(apiUrl, {
                                    method: 'POST',
                                    mode: 'cors',
                                    headers: {
                                        'Content-Type': 'application/json'
                                    },
                                    body: JSON.stringify({
                                        query: "{\n            __schema {\n              types {\n                name\n              }\n            }\n          }",
                                        operationName: null,
                                        variables: {}
                                    })
                                })];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_1 = _a.sent();
                            throw new Error('Gagal mendapatkan koneksi, pastikan device anda dalam satu jaringan');
                        case 4: 
                        // apply configurations
                        return [4 /*yield*/, this.setClientConfig({
                                apiUrl: apiUrl,
                                subscriptionUrl: subscriptionUrl,
                                token: '--ec-on-device-token--'
                            })];
                        case 5:
                            // apply configurations
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return EdgeCentralClient;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        EdgeCentralClient.prototype.store;
        /** @type {?} */
        EdgeCentralClient.prototype.client;
        /**
         * @type {?}
         * @private
         */
        EdgeCentralClient.prototype.httpProtocol;
        /**
         * @type {?}
         * @private
         */
        EdgeCentralClient.prototype.wsProtocol;
        /**
         * @type {?}
         * @private
         */
        EdgeCentralClient.prototype.config;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ec.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Load apollo client on booting
     * @param {?} ec
     * @return {?}
     */
    function initEdgeCentralClient(ec) {
        /** @type {?} */
        var loader = (/**
         * @return {?}
         */
        function () { return ec.loadApolloClient(); });
        return loader;
    }
    /**
     * wrapped edge central client so it injectable
     * @param {?} config
     * @return {?}
     */
    function provideEdgeCentralService(config) {
        return new EdgeCentralClient(config);
    }
    /**
     *
     * @export
     */
    var EdgeCentralModule = /** @class */ (function () {
        /**
         * Creates an instance of EdgeCentralModule.
         * throw error if EdgeCentralModule already created on parent
         */
        function EdgeCentralModule(parentModule) {
            if (parentModule) {
                throw new Error('EdgeCentralModule is already loaded. Import it in the AppModule only');
            }
        }
        /**
         * Create new module instance with edge central config service
         *
         */
        /**
         * Create new module instance with edge central config service
         *
         * @param {?} config
         * @return {?}
         */
        EdgeCentralModule.forRoot = /**
         * Create new module instance with edge central config service
         *
         * @param {?} config
         * @return {?}
         */
        function (config) {
            return {
                ngModule: EdgeCentralModule,
                providers: [{ provide: EdgeCentralConfig, useValue: config }]
            };
        };
        EdgeCentralModule.decorators = [
            { type: core.NgModule, args: [{
                        providers: [
                            {
                                provide: EdgeCentralClient,
                                useFactory: provideEdgeCentralService,
                                deps: [EdgeCentralConfig]
                            },
                            // intiate edge central client on booting
                            {
                                provide: core.APP_INITIALIZER,
                                useFactory: initEdgeCentralClient,
                                deps: [EdgeCentralClient],
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        EdgeCentralModule.ctorParameters = function () { return [
            { type: EdgeCentralModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
        ]; };
        return EdgeCentralModule;
    }());

    exports.EdgeCentralClient = EdgeCentralClient;
    exports.EdgeCentralConfig = EdgeCentralConfig;
    exports.EdgeCentralModule = EdgeCentralModule;
    exports.initEdgeCentralClient = initEdgeCentralClient;
    exports.provideEdgeCentralService = provideEdgeCentralService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sirusdev-ec-client-angular.umd.js.map
