import { Router } from '@angular/router';
import { ToastController, LoadingController } from '@ionic/angular';
import { EdgeCentralClient } from '@sirusdev/ec-client-angular';
export declare class LoginPage {
    private toast;
    private loading;
    private router;
    private ec;
    tab: string;
    deviceID: string;
    providerID: string;
    password: string;
    constructor(toast: ToastController, loading: LoadingController, router: Router, ec: EdgeCentralClient);
    tabChanged(event: {
        detail: {
            value: string;
        };
    }): void;
    loginDevice(): Promise<void>;
    loginProvider(): Promise<void>;
}
